(function() {
	'use strict';

	angular
		.module('barebone.busbook')
		.controller('BusbookController', BusbookController);

	BusbookController.$inject = [
		'busService',
		'FontDetectService',
		'$timeout',
		'$scope',
		'$state',
		'motion',
		'$rootScope',
		'$ionicPopup',
		'$ionicModal',
		'$http',
		'$auth',
		'$stateParams',
		'$ionicHistory',
		'$window',
		'$filter',
		'ENV',
		'bus'
	];

	/* @ngInject */
	function BusbookController(
		busService,FontDetectService,$timeout,$scope,$state,motion,$rootScope,$ionicPopup,$ionicModal,$http,$auth,$stateParams,$ionicHistory,$window,$filter,ENV,bus) {

		$ionicHistory.nextViewOptions({
	            historyRoot: true
	    	});
		$scope.today = new Date();
		
		var searchResult = $rootScope.searchResult;
		
		var userInfo     = $rootScope.userInfo || {};

		var vm = angular.extend(this, {
			 		disabled_book : false,
					liveSite 	 : ENV.liveSite,
					userInfo 	 : userInfo,
					hidefab 	 : true,
					bus 		 : bus,
					booking 	 : {},
					transfer_payment : false,
					truemoney_payment : false,
					onetwothree_payment : false,
					paypal_payment : false,
					visa_master_payment : false,
					mab_payment : false,
					mpu_payment : false,
				kbz_direct_payment : false,
					deposite_payment : false,
					kbz_pay_payment : false,
					searchResult : searchResult,
				   seatExpirysec : parseInt($rootScope.seatExpirymin)*60,
			from_destination 	 : searchResult.from_destination,
			to_destination     	 : searchResult.to_destination,
				offerAmount      : $rootScope.offerAmount,
					type 		 : searchResult.type,
					redirectHome : redirectHome,
					changeMode	 : changeMode,
			showconfirmation	 : showconfirmation,
					promo_code   : searchResult.promo_code,
					conBooking	 : conBooking,
					changeName	 : changeName,
					dollar_rate  : $window.localStorage['dollar_rate'],
					type        : searchResult.type
		});

			$ionicModal.fromTemplateUrl('scripts/booking/booking-confirm.html', {
					    vm: vm,
					    scope: $scope,
					    animation: 'slide-in-down'
			}).then(function(modal) {
					    $scope.modal = modal;
			});


		motion.expandHeader();
		// **********************************************

		var busId = parseInt($stateParams.busId);

			// if(vm.bus.sell_price < 10000)
	  //   		searchResult.deposit_fee = -300;

			vm.booking.adult      = parseInt(searchResult.adult);
			vm.booking.bus_id     = busId;
			vm.booking.traveldate = searchResult.traveldate;
			
			vm.booking.type     = searchResult.type;
			vm.booking.passenger_type        = searchResult.passenger_type;
			vm.booking.seat_id     = searchResult.seat_id;
			vm.booking.selected_seat     = searchResult.selected_seat;
			vm.booking.seat_no           = searchResult.seat_no;
			vm.booking.accept_terms   = '';
			vm.booking.mobile   = '';
			vm.booking.payment  = '';
			vm.booking.boarding_point  = bus.boarding_point[0].name;
			vm.booking.dropping_point  = bus.dropping_point[0].name;
			vm.booking.note  	= '';
			vm.booking.transcation  = 'TXN Fees';
			vm.booking.transcation_fees  = 0;
			vm.booking.service_fees  = 0;

			vm.booking.service = 0;

			if(!$rootScope.userInfo){
				vm.booking.member_id  = 0;
				vm.booking.price   = parseFloat(vm.bus.local_sell_price);
			}
			else{
				vm.booking.member_id  = $rootScope.userInfo.id;
				if(typeof $rootScope.userInfo != 'undefined' && $rootScope.userInfo.is_reseller === 1){
					if(vm.booking.type == 'local'){
						vm.booking.price   = parseFloat(vm.bus.local_reseller_price);
					}
					else{
						vm.booking.price   = parseFloat(vm.bus.foreigner_reseller_price);
					}
				}
				else{
					if(vm.booking.type == 'local'){
						vm.booking.price   = parseFloat(vm.bus.local_sell_price);
					}
					else{
						vm.booking.price   = parseFloat(vm.bus.foreigner_sell_price);
					}
				}
			}

			vm.booking.total	= (vm.booking.adult*vm.booking.price);

			busService.getServicefees(vm.booking.total)
				.then(function(serviceFees) {
					vm.booking.transcation_fees = serviceFees.transfer_fee;
					if(serviceFees.transfer_fee) vm.transfer_payment = true;
					if(serviceFees.truemoney_fee) vm.truemoney_payment = true;
					if(serviceFees.onetwothree_fee) vm.onetwothree_payment = true;
					if(serviceFees.paypal_fee) vm.paypal_payment = true;
					if(serviceFees.visa_master_fee) vm.visa_master_payment = true;
					if(serviceFees.mab_fee) vm.mab_payment = true;
					if(serviceFees.mpu_fee) vm.mpu_payment = true;
					if(serviceFees.kbz_direct_fee) vm.kbz_direct_payment = true;
					if(serviceFees.kbz_pay_fee) vm.kbz_pay_payment = true;
					if(typeof $rootScope.userInfo != 'undefined' && serviceFees.deposite_fee == 0 || serviceFees.deposite_fee > 0) vm.deposite_payment = true;
					
					if(!$rootScope.userInfo && !serviceFees.transfer_fee && !serviceFees.truemoney_fee && !serviceFees.onetwothree_fee && !serviceFees.paypal_fee && !serviceFees.visa_master_fee && !serviceFees.mab_fee && !serviceFees.mpu_fee){
						$ionicPopup.alert({
							    title: 'Sorry',
							    template: 'There is no payment avaliable for booking.Please login and checkout with Deposite Account!'
							  });
						$state.go('app.buslist');
					}

					// vm.booking.payment = 'mpu';
					// changeMode();
			});

		function detectFont(text){
			return FontDetectService.fontDetect(text);
		}

		function changeName(text){
			vm.booking.pname = text;
		}
		
		function redirectHome(){
			$state.go('app.home');
		}

		function changeMode(){

			if(vm.booking.type == 'local'){
				if(typeof $rootScope.userInfo != 'undefined' && $rootScope.userInfo.is_reseller === 1){
					vm.booking.price   = parseFloat(vm.bus.local_reseller_price);
				}
				else{
					vm.booking.price   = parseFloat(vm.bus.local_sell_price);
				}
			}else{
				if(typeof $rootScope.userInfo != 'undefined' && $rootScope.userInfo.is_reseller === 1){
					vm.booking.price   = parseFloat(vm.bus.foreigner_reseller_price);
				}
				else{
					vm.booking.price   = parseFloat(vm.bus.foreigner_sell_price);
				}
			}
			vm.booking.total	= (vm.booking.adult*vm.booking.price);


			busService.getServicefees(vm.booking.total)
				.then(function(serviceFees) {
					
					if(vm.booking.payment == 'transfer'){
						vm.booking.transcation_fees = serviceFees.transfer_fee;
						vm.booking.service_fees = serviceFees.transfer_fee;
					}
					else if(vm.booking.payment == 'mpu'){
						vm.booking.transcation_fees = serviceFees.mpu_fee;
						vm.booking.service_fees = serviceFees.mpu_fee;
					}
					else if(vm.booking.payment == 'kbz_direct'){
						vm.booking.transcation_fees = serviceFees.kbz_direct_fee;
						vm.booking.service_fees = serviceFees.kbz_direct_fee;
					}
					else if(vm.booking.payment == 'onetwothree'){
						vm.booking.transcation_fees = serviceFees.onetwothree_fee;
						vm.booking.service_fees = serviceFees.onetwothree_fee;
					}
					else if(vm.booking.payment == 'paypal'){
						vm.booking.transcation_fees = serviceFees.paypal_fee;
						vm.booking.service_fees = serviceFees.paypal_fee;
					}
					else if(vm.booking.payment == 'visa_master'){
						vm.booking.transcation_fees = serviceFees.visa_master_fee;
						vm.booking.service_fees = serviceFees.visa_master_fee;
					}
					else if(vm.booking.payment == 'truemoney'){
						vm.booking.transcation_fees = serviceFees.truemoney_fee;
						vm.booking.service_fees = serviceFees.truemoney_fee;
					}
					else if(vm.booking.payment == 'kbz_pay'){
						vm.booking.transcation_fees = serviceFees.kbz_pay_fee;
						vm.booking.service_fees = serviceFees.kbz_pay_fee;
					}
					else{
						vm.booking.transcation_fees = serviceFees.deposite_fee;
						vm.booking.service_fees = serviceFees.deposite_fee;
					}

					if(vm.offerAmount.offer_amount){
						vm.booking.transcation_fees -= vm.offerAmount.offer_amount;
					}

			});

		}

		function showconfirmation(){
	 	 	 	 
	 	 	 	 var promo_text = '';
				 if(vm.offerAmount.offer_amount){
					promo_text += '<b>'+vm.offerAmount.offer_name + ' : -' + vm.offerAmount.offer_amount+'</b><br><br>';
				 }

	 	 	 	 var amount = parseFloat(vm.booking.total) + parseFloat(vm.booking.transcation_fees);

	 	 		 var depature_time = $filter('date')(($filter('date')(new Date(), 'y-MM-dd') +'T'+vm.bus.departure_time+':00'), "h:mm a");

	 	 		 vm.des = "Are you sure want to this book <b>"+ vm.from_destination + "</b> To <b>" + vm.to_destination+
	 	      			   "</b> Bus? <br><br>Travel Date : <b>"+ vm.booking.traveldate + "</b> <br><br>"+
	 	      			   $rootScope.appLang.depature_time +" : <b>"+ depature_time + "</b><br><br>"+
	 	      			   promo_text+
	 	      			   " Transcation Fees : <b>"+ vm.booking.service_fees + "</b><br><br>"+
	 	      			   " Total Amount : <b>"+ amount + "</b><br><br>"+
	 	      			   "Payment Method : <b>"+ vm.booking.payment+"</b>";

			  $scope.modal.show();		
			  
			  //Cleanup the modal when we're done with it!
			  $scope.$on('$destroy', function() {
			    $scope.modal.remove();
			  });
			  // Execute action on hide modal
			  $scope.$on('modal.hidden', function() {
			    // Execute action
			  });
			  // Execute action on remove modal
			  $scope.$on('modal.removed', function() {
			    // Execute action
			  });


		}

		function conBooking(){

			$scope.modal.hide();
			vm.disabled_book = true;

			var amount = parseFloat(vm.booking.total) + parseFloat(vm.booking.transcation_fees);

			if(vm.booking.payment == 'account')
			{
				if($rootScope.userInfo && amount > $rootScope.userInfo.money)
				{
					$ionicPopup.alert({
							            title: 'Insufficient Fund!',
							            content: 'Sorry,you don\'t have enough fund in your account.<br>Please try another payment method!'
							          });
					return false;
				}
				if(!$rootScope.userInfo)
				{
					$ionicPopup.alert({
							            title: 'Please Login',
							            content: 'Sorry,you didn\'t login or register yet.<br>Please login to your account first!'
							          });
					$state.go('app.login');
					return false;
				}

				vm.payment_complete = 1;
			}
			else{
				vm.payment_complete = 0;
			}
			
			if($rootScope.userInfo){
				vm.booking.member_id = $rootScope.userInfo.id;
			}

			if(ionic.Platform.isAndroid()) {
				vm.booking.ostype = "Android";
			}else{
				vm.booking.ostype = "iOS";
			}

	 	 	var total_amount = 0;
			if(vm.booking.type == 'local'){
				total_amount = vm.booking.adult * vm.bus.local_sell_price;
			}
			else{
				total_amount = vm.booking.adult * vm.bus.foreigner_sell_price;
			}

				var booking_data = {
									bus_id			  : vm.booking.bus_id,
									travel_date		  : vm.booking.traveldate,
									nrc_no			  : vm.booking.nrc_no,
									guest_name	      : vm.userInfo.name,
									guest_email	      : vm.userInfo.email,
									guest_mobile	  : vm.booking.mobile,
									passenger_name	  : vm.booking.pname,
									boarding_point	  : vm.booking.boarding_point,
									dropping_point	  : vm.booking.dropping_point,
							original_selling_price	  : total_amount,
									amount			  : amount,
								  offer_code		  : vm.promo_code,
								offer_amount		  : vm.offerAmount.offer_amount || 0,
									service 		  : vm.booking.service_fees,
									adult			  : vm.booking.adult,
									selected_seat	  : vm.booking.selected_seat,
									seat_no			  : vm.booking.seat_no,
									seat_id			  : vm.booking.seat_id,
									note			  : vm.booking.note,
									type			  : vm.booking.type,
									passenger_type    : vm.booking.passenger_type,
									member_id		  : vm.booking.member_id,
									ostype		  	  : vm.booking.ostype,
									payment_complete  : vm.payment_complete,
									payment_method	  : vm.booking.payment
								};

						$http.post(ENV.apiEndpoint+'make_payment?token='+$auth.getToken(),booking_data).success(function(response) {

									$rootScope.bookedsuccess = response;

									if(vm.booking.payment == 'transfer'){
										$state.go('app.transfer');
									}
									else if(vm.booking.payment == 'truemoney'){
										$state.go('app.truemoney');
									}
									else if(vm.booking.payment == 'account'){
										$state.go('app.deposite');
									}
									if(vm.booking.payment=='kbz_pay'){
										var booking_id = response.encrypt_booking_id;
										var url = ENV.liveSite+'booking/payment_confirmation/'+vm.booking.payment+'/'+booking_id;
										var ref = $window.open(url, '_system', 'closebuttoncaption='+$rootScope.appLang.back);
									}
									else{

										var booking_id = response.encrypt_booking_id;
										var url = ENV.liveSite+'booking/payment_confirmation/'+vm.booking.payment+'/'+booking_id;

										$window.open(url, '_blank', 'closebuttoncaption=Back to App,enableviewportscale=yes');	
										$ionicPopup.alert({
										            title: 'Success',
										            content: 'Your Booking has been saved successfully.<br>Please feel free to email '+ENV.email+' if you need further information or assistance.'
										          });
										$state.go('app.home');

									}
														
						}).error(function(response){
							$ionicPopup.alert({
							            title: 'Error!',
							            content: response.message
							          });
							$state.go('app.busSearch');
						});

			
		}

	}
})();