(function() {
	'use strict';

	angular
		.module('barebone.transfer')
		.controller('TransferController', TransferController);

	TransferController.$inject = [
		'busService',
		'$timeout',
		'$state',
		'$rootScope',
		'$http',
		'$ionicHistory',
		'motion',
		'ENV'
	];

	/* @ngInject */
	function TransferController(
		busService, $timeout,$state,$rootScope,$http,$ionicHistory,motion,ENV) {
		
		$ionicHistory.nextViewOptions({
            historyRoot: true
    	});

		var bookedsuccess = $rootScope.bookedsuccess;

		var vm = angular.extend(this, {
			bookedsuccess : bookedsuccess,
			bank		  : {},
			doBankinfo	  : doBankinfo
		});


			vm.bank.name = '';
			vm.bank.remark = '';
			vm.bank.ref = vm.bookedsuccess.ref;

			motion.expandHeader();

			function doBankinfo(){

						var bank_data = {
										encrypt_booking_id: vm.bookedsuccess.encrypt_booking_id,
										bank_name			  : vm.bank.name,
										remark   		  : vm.bank.remark,
										ref      		  : vm.bookedsuccess.ref
									};

						$http.post(ENV.apiEndpoint+'save_bank_info',bank_data).then(function(response) {
									$rootScope.bank = response.data;
									$state.go('app.bank');																
						});

				
			}

	}
})();