(function() {
	'use strict';

	angular
		.module('barebone.busdetail')
		.controller('BusdetailController', BusdetailController);

	BusdetailController.$inject = [
		'busService',
		'$timeout',
		'$scope',
		'$state',
		'motion',
		'$rootScope',
		'$stateParams',
		'$window',
		'ENV'
	];

	/* @ngInject */
	function BusdetailController(
		busService, $timeout,$scope,$state,motion,$rootScope,$stateParams,$window,ENV) {

		$scope.today = new Date();

		
		var busId = parseInt($stateParams.busId);
		var seatId = parseInt($stateParams.seatId);

		var searchResult = $rootScope.searchResult;

		var vm = angular.extend(this, {
			liveSite 	 : ENV.liveSite,
			avaliable	 : $rootScope.avaliable,
			bus 		 : [],
			busId 		 : busId,
			dollar_rate	 : $window.localStorage['dollar_rate'],
			seatId 		 : seatId,
		checkDate 		 : checkDate,
		traveldate 		 : searchResult.traveldate,
	before_block_min     : $rootScope.before_block_min,
	from_destination 	 : searchResult.from_destination,
	to_destination 		 : searchResult.to_destination,
		});

		motion.expandHeader();
		// **********************************************

		busService.get(busId)
				.then(function(bus) {
					vm.bus = bus;
		});

		function checkDate(travel_date){
			var dtravel_date = travel_date.split('-');
			var min  	=  dtravel_date[3].split(':');

			var departure_date = new Date(dtravel_date[2],dtravel_date[1]-1,dtravel_date[0],min[0],min[1]);

			var current_date = new Date();
			var hours = parseInt(vm.before_block_min/60);
			var minutes = parseInt(vm.before_block_min%60);

			departure_date.setHours(departure_date.getHours() - hours);
			departure_date.setMinutes(departure_date.getMinutes() - minutes);

			if(current_date <= departure_date){
				return true;
			}
			else{
				return false;
			}
		}

	}
})();