(function() {
	'use strict';

	angular
		.module('barebone.home')
		.factory('homeDataService', homeDataService);

	homeDataService.$inject = ['$http', '$q','$auth','$ionicPopup', 'ENV'];

	/* @ngInject */
	function homeDataService($http, $q, $auth,$ionicPopup,ENV) {

		var url = ENV.apiEndpoint;
		var result = [];

		return {
			phoneNumber: ENV.phone1,
			email: ENV.email,
			facebookPage: 'https://www.facebook.com/'+ENV.facebookPage,
			searchId: searchId,
			updateprofile: updateprofile
		};


	// *******************************************************

	function searchId(ref){

			var deferred = $q.defer();
			$http.get(url+'trackchange_ticket?ref='+ref)
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					// result = data.result;
					deferred.resolve(data);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Search):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}

	function updateprofile(credentials){

			var deferred = $q.defer();
			$http.put(url+'profile?token='+$auth.getToken(),credentials)
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					result = data;
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
						$ionicPopup.alert({
				            title: 'Error',
				            content: data.message || 'Can\'t establish internet connection.'
				          });
						return $q.reject();
				});
			return deferred.promise;
	}

}

})();