(function() {
	'use strict';

	angular
		.module('barebone.home')
		.controller('HomeController', HomeController);

	HomeController.$inject = [
		'menuItems',
		'homeDataService',
		'externalAppsService',
		'$cordovaEmailComposer',
		'$timeout',
		'$state',
		'$rootScope',
		'$scope',
		'$window',
		'$ionicHistory',
		'$ionicPopup',
		'$http',
		'ENV',
		'motion'
	];

	/* @ngInject */
	function HomeController(
		menuItems, homeDataService, externalAppsService, $cordovaEmailComposer, $timeout,$state,$rootScope,$scope,$window,$ionicHistory,$ionicPopup,$http,ENV,motion) {

		var vm = angular.extend(this, {
			entries: menuItems,
			phoneNumber: homeDataService.phoneNumber,
			searchTicket: searchTicket,
			claimCoupon: claimCoupon,
			sendEmail: sendEmail,
			openFacebookPage: openFacebookPage,
		});

		(function activate() {
			motion.collapseHeader();
			motion.ink();

			$timeout(function() {
				ionic.material.motion.fadeSlideInRight({
					startVelocity: 3000
				});
			}, 200);
		})();

		// **********************************************************

		function searchTicket() {

			$state.go('app.searchticket');

		}

		function claimCoupon() {
			$scope.data = { claim_coupon:'' };
			$ionicPopup.show({
			    template: '<input type="text" ng-model="data.claim_coupon">',
			    title: $rootScope.appLang.claim_coupon,
			    scope: $scope, 
			    buttons: [
			      			{ text: $rootScope.appLang.back },
					      	{
						        text: $rootScope.appLang.claimed,
						        type: 'button-positive',
						        onTap: function(e) 
						        {
						          if($scope.data.claim_coupon){
						          	$http.post(ENV.apiEndpoint +'claim_coupon',{'claim_coupon':$scope.data.claim_coupon})
									.success(function(response){
										$ionicPopup.alert({
										            title: 'Info',
										            content: response.message
										          });
										$scope.data.claim_coupon = '';
					                 })
					                .error(function(errors){
						            	// 	  $ionicPopup.alert({
								          //   title: 'Invalid',
								          //   content: 'Invalid or Expired Coupon Code, please enter it correctly!'
								          // });
					                });
						          }
						          
					            }
		      			    }
		    		    ]
			});

		}

		function sendEmail() {
			$cordovaEmailComposer.isAvailable().then(function() {
				var email = {
					to: homeDataService.email,
					subject: $rootScope.appName +' Enquiry',
					body: ''
				};

				$cordovaEmailComposer.open(email);
			});
		}

		function openFacebookPage() {
			externalAppsService.openExternalUrl(homeDataService.facebookPage);
		}
	}
})();