(function() {
	'use strict';

	angular
		.module('starter')
		.config(function($httpProvider) {
			
			$httpProvider.defaults.useXDomain = true;

			$httpProvider.interceptors.push(function($cordovaNetwork, $q, $rootScope, $injector,$location,ConnectivityMonitor,ENV) {
				return {
				        request: function(config) {
					        	  
					        	if(!(config.url).includes('authenticate') && !(config.url).includes('seats_blocked')){
					        		$rootScope.$broadcast('loading:show');
					        	}

			                    config.headers['Accept'] = 'application/json';
			                    config.headers['X-API-KEY'] = ENV.API_KEY;
			                    config.headers['X-API-SECRET'] = ENV.API_SECRET;

			                    if (!ionic.Platform.isReady) {
			                      return config;
			                    }

			                    if (config.url.indexOf('http') !== 0) {
			                      return config;
			                    }

			                    if (ConnectivityMonitor.isOnline()) {
			                      return config;
			                    }

			                    var $cordovaToast = $injector.get('$cordovaToast');
			                    $cordovaToast.showLongBottom('There is no internet connection.');
			                    $rootScope.$broadcast('loading:hide');
			                    return $q.reject('No internet connection');

			                  },
			                  response: function(response) {
			                    $rootScope.$broadcast('loading:hide');
			                    return response;
			                  },
			                  responseError: function(rejectReason) {
			                  	$rootScope.$broadcast('loading:hide');
			                    var $cordovaToast = $injector.get('$cordovaToast');
			                     if(rejectReason.status === 426) {
			                        var $ionicPopup = $injector.get('$ionicPopup');
			                        $ionicPopup.show({
									   title : 'Update Required!',
									   template : rejectReason.data.message || 'Your application need to update for more useful features.Please update to continue.',
									   buttons : [
													   {
													    text : 'Exit',
													    type : 'button-positive',
													    onTap : function() {
															     ionic.Platform.exitApp();
															    }
													   }
												]
									});
			                     }
			                     else if(rejectReason.status === 404) {
			                        var $ionicPopup = $injector.get('$ionicPopup');
			                            $ionicPopup.alert({
			                              title: 'Not Found',
			                              content: rejectReason.data.error.message
			                            });
			                        return $q.reject(rejectReason);
			                     }
			                     else if(rejectReason.status === 401){
			                     	return $q.reject(rejectReason);
			                     }
			                     else{
			                     	if(internet_count < 3){
			                     		internet_count++;
			                        	$cordovaToast.showLongBottom("There is no internet connection.");
			                     	}
			                     	return $q.reject(rejectReason);
			                     }
			                  },
			                  requestError: function(rejectReason) {
			                    $rootScope.$broadcast('loading:hide');
			                    return $q.reject(rejectReason);
			                  }
				};

			});
		});
})();