(function() {
	'use strict';

	angular
		.module('barebone.member')
		.factory('memberService', memberService);

	memberService.$inject = ['$http', '$q','$auth', 'ENV','$ionicPopup','$ionicLoading'];

	/* @ngInject */
	function memberService($http, $q,$auth, ENV,$ionicPopup,$ionicLoading) {

		var url = ENV.apiEndpoint;
		var result = [];

		return {
			doLogIn: doLogIn,
			setUser: setUser,
			getUser: getUser
		};

	// *******************************************************

	function doLogIn(mobile,password){

			var deferred = $q.defer();
			var credentials = {
					mobile: mobile,
					password: password
 			};

			// Use Satellizer's $auth service to login
			$auth.login(credentials).then(function(data) {
				result = data.result;
				deferred.resolve(result);

			}, function(data, status, headers, config) {
				// or server returns response with an error status.
					console.log('ERROR (Login):' + status);
					$ionicLoading.hide();
					$ionicPopup.alert({
			            title: 'Error',
			            content: data.data.error || 'Can\'t establish internet connection.'
			        });
					deferred.reject(result);
				});
			return deferred.promise;
	}

	function setUser(user_data) {
    	window.localStorage.starter_facebook_user = JSON.stringify(user_data);
  	}

  	function getUser(){
	    return JSON.parse(window.localStorage.starter_facebook_user || '{}');
	}


}

})();