(function() {
	'use strict';

	angular
		.module('barebone.mydeposite')
		.factory('mydepositeService', mydepositeService);

	mydepositeService.$inject = ['$http', '$q','$auth', 'ENV','$ionicPopup','$ionicLoading'];

	/* @ngInject */
	function mydepositeService($http, $q,$auth, ENV,$ionicPopup,$ionicLoading) {

		var url = ENV.apiEndpoint;
		var result = [];

		return {
			getDeposite: getDeposite
		};


	// *******************************************************

	function getDeposite(page){

			var deferred = $q.defer();
			
			$http.get(url+'mymoney?page='+page+'&token='+$auth.getToken(),{}).then(function(data) {

						result = data;
						deferred.resolve(result);

					}, function(error) {
						$ionicLoading.hide();
						$ionicPopup.alert({
				            title: 'Error',
				            content: 'Can\'t establish internet connection.'
				          });
						deferred.reject(result);
					});

			return deferred.promise;

	}

}

})();