(function() {
	'use strict';

	angular
		.module('barebone.page')
		.factory('pageService', pageService);

	pageService.$inject = ['$http','$window', '$q', 'ENV','AppDB','LANG'];

	/* @ngInject */
	function pageService($http,$window, $q, ENV,AppDB,LANG) {

		var url = ENV.apiEndpoint;
		var result = [];
    	var lang_val = $window.localStorage['appLang'] || LANG.lang;


		return {
			getAbout: getAbout,
			getTnc  : getTnc,
			getFaq  : getFaq
		};


	// *******************************************************

	function getAbout(){

			var deferred = $q.defer();
			$http.get(url+'page/about_us')
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					var   tempList = [];
			        		tempList.route = 'app.about';
			        		tempList.data = JSON.stringify(data);
					AppDB.addorupdate(tempList,true);

					if(lang_val === 'english')
		    		{
						result = data.en_result;
		    		}
		    		else
		    		{
						result = data.result;
		    		}

					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (About):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}

	// *******************************************************

	function getTnc(){

			var deferred = $q.defer();
			$http.get(url+'page/terms_conditions')
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					var   tempList = [];
			        		tempList.route = 'app.tnc';
			        		tempList.data = JSON.stringify(data);
					AppDB.addorupdate(tempList,true);
					if(lang_val === 'english')
		    		{
						result = data.en_result;
		    		}
		    		else
		    		{
						result = data.result;
		    		}
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (Tnc):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}


	// *******************************************************

	function getFaq(){

			var deferred = $q.defer();
			$http.get(url+'page/faq')
				.success(function(data, status, headers, config) {
					// this callback will be called asynchronously
					// when the response is available
					var   tempList = [];
			        		tempList.route = 'app.faq';
			        		tempList.data = JSON.stringify(data);
					AppDB.addorupdate(tempList,true);
					if(lang_val === 'english')
		    		{
						result = data.en_result;
		    		}
		    		else
		    		{
						result = data.result;
		    		}
					deferred.resolve(result);
				})
				.error(function(data, status, headers, config) {
					// called asynchronously if an error occurs
					// or server returns response with an error status.
					console.log('ERROR (FAQs):' + status);
					deferred.reject(result);
				});
			return deferred.promise;
	}

}

})();