(function() {
	'use strict';

	angular
		.module('barebone.ticketchanges')
		.factory('ticketchangesService', ticketchangesService);

	ticketchangesService.$inject = ['$http', '$q','$auth', 'ENV','$ionicPopup','$ionicLoading'];

	/* @ngInject */
	function ticketchangesService($http, $q,$auth, ENV,$ionicPopup,$ionicLoading) {

		var url = ENV.apiEndpoint;
		var result = [];

		return {
			getChangesbooking: getChangesbooking,
			getTicketchanges: getTicketchanges
		};


	// *******************************************************

	function getChangesbooking(bookingId){

			var deferred = $q.defer();
			
			$http.get(url+'changes_booking?booking_id='+bookingId+'&token='+$auth.getToken(),{}).then(function(data) {

						result = data.data.result;
						deferred.resolve(result);

					}, function(error) {
						$ionicLoading.hide();
						$ionicPopup.alert({
				            title: $rootScope.appLang.invalid,
				            content: $rootScope.appLang.cant_establish_conn
				          });
						deferred.reject(result);
					});

			return deferred.promise;

	}

	function getTicketchanges(page){

			var deferred = $q.defer();
			
			$http.get(url+'ticketchanges?page='+page+'&token='+$auth.getToken(),{}).then(function(data) {

						result = data;
						deferred.resolve(result);

					}, function(error) {
						$ionicLoading.hide();
						$ionicPopup.alert({
				            title: $rootScope.appLang.invalid,
				            content: $rootScope.appLang.cant_establish_conn
				          });
						deferred.reject(result);
					});

			return deferred.promise;

	}

}

})();